'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

var getByPathInternal = function getByPathInternal(_ref) {
  var input = _ref.input,
      path = _ref.path,
      options = _ref.options;

  if (path.length === 0) {
    return input;
  }

  if (input == null) {
    return undefined;
  }

  var _path = _toArray(path),
      first = _path[0],
      rest = _path.slice(1);

  if (first.indexOf('$') !== 0) {
    return getByPathInternal({ input: input[first], path: rest, options: options });
  }

  if (!Array.isArray(input)) {
    return undefined;
  }

  var id = first.substr(1);
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = input[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var one = _step.value;

      if (one[options.idToken] === id) {
        return getByPathInternal({ input: one, path: rest, options: options });
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return undefined;
};

var parse = function parse(_ref2) {
  var input = _ref2.input,
      json = _ref2.json,
      context = _ref2.context,
      parentContext = _ref2.parentContext,
      options = _ref2.options;

  if (!input) {
    return input;
  }

  if ((typeof input === 'undefined' ? 'undefined' : _typeof(input)) !== 'object') {
    return input;
  }

  if (Array.isArray(input)) {
    return jrefInternal({ input: input, json: json, context: context, parentContext: parentContext, options: options });
  }

  var result = _extends({}, input);
  var ref = result[options.refToken];
  delete result[options.refToken];

  var id = result[options.idToken];

  if (id) {
    parentContext = context;
    context = result;
  }

  if (!ref) {
    return jrefInternal({ input: result, json: json, context: context, parentContext: parentContext, options: options });
  }
  var refPath = ref.substr(2).split('/');

  var value = void 0;
  if (refPath[0] === options.thisToken) {
    value = getByPathInternal({ input: context, path: refPath.slice(1), options: options });
  } else if (refPath[0] === options.parentToken) {
    value = getByPathInternal({ input: parentContext, path: refPath.slice(1), options: options });
  } else {
    value = getByPathInternal({ input: json, path: refPath, options: options });
  }

  if ((typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' && !Array.isArray(value)) {
    result = _extends({}, value, result);
  } else {
    result = value;
  }

  return jrefInternal({ input: result, context: context, parentContext: parentContext, json: json, options: options });
};

var jrefInternal = function jrefInternal(_ref3) {
  var input = _ref3.input,
      json = _ref3.json,
      context = _ref3.context,
      parentContext = _ref3.parentContext,
      options = _ref3.options;

  if ((typeof input === 'undefined' ? 'undefined' : _typeof(input)) !== 'object') {
    return input;
  }

  if (Array.isArray(input)) {
    return input.map(function (one) {
      return parse({ input: one, json: json, context: context, parentContext: parentContext, options: options });
    });
  }

  return Object.keys(input).reduce(function (agg, key) {
    agg[key] = parse({ input: input[key], json: json, context: context, parentContext: parentContext, options: options });
    return agg;
  }, {});
};

var defaultOptions = {
  idToken: '$id',
  refToken: '$ref',
  thisToken: '$this',
  parentToken: '$parent'
};

var jref = function jref(json, options) {
  options = _extends({}, defaultOptions, options);

  return jrefInternal({ input: json, json: json, context: json, parentContext: json, options: options });
};

var getByPath = function getByPath(json, path, options) {
  options = _extends({}, defaultOptions, options);

  return getByPathInternal({ input: json, path: path, options: options });
};

exports.getByPath = getByPath;
exports.default = jref;